#!/usr/local/bin/php
<?php
/*
	Search for and display wordpress databases containing user id > 1000000

	Version: 0.1
	Author: Artefact.io

	Usage
	wphunt.php -cnf <path to .my.cnf>
	
	DISCLAIMER: This program is provided with no warranty of any kind. Use at your own risk.
*/
error_reporting(E_ALL);

// Input
$args=parse_cli_args();

$host='localhost';
$user='';
$pass='';

if (isset($args['cnf'])) {
	$tmp=parse_ini_file($args['cnf']);
	$user=$tmp['user'];
	$pass=$tmp['password'];
	echo "Using username '$user'\n";
}

// Connect
mysql_connect($host, $user, $pass, true) or die("Connect error\n");

// List databases
$databases=array();
$q=mysql_query('SHOW DATABASES') or die("\nERROR *** ".mysql_error()."\n");
while ($r=mysql_fetch_row($q)) $databases[]=$r[0];

if (empty($databases)) die("No databases\n");
echo "Found ".count($databases)." databases\n";

foreach ($databases as $database) {
	
	// get tables; using reversed key-value array for speed
	$tables=array();
	$q=mysql_query('SHOW TABLES FROM `'.$database.'` LIKE "wp%"') or die("\nERROR *** ".mysql_error()."\n");
	while ($r=mysql_fetch_row($q)) $tables[$r[0]]=true;
	
	if (empty($tables)) continue; // skip if empty
	
	if (!isset($tables['wp_users'])) continue; // skip if wp_users does not exists
		
	// Get highest ID from wp_users table
	$q=mysql_query('SELECT MAX(ID) FROM `'.$database.'`.`wp_users`') or die("\nERROR *** ".mysql_error()."\n");
	$r=mysql_fetch_row($q);
		
	if ($r[0] > 1000000) echo $database.' ID '.$r[0]."\n";

}


/*
	Parse CLI args 1.0

  Windows: php -f script.php -- <args>
  Linux:   ./script.php <args>

	example args:
		-key1 value1 -key2 value2 unnamed1 unnamed2

	return array
	_cmd 			script filename
	_other 		unnamed arguments
	key1,..		named arguments
*/

function parse_cli_args() {
	
	if (PHP_SAPI!='cli') return false;
	
	$args=array('_cmd' => $_SERVER['argv'][0], '_other' => array() );
	
	$argn='';
	for ($i=1; $i<=$_SERVER['argc']-1; $i++) {
		if (substr($_SERVER['argv'][$i],0,1)=='-') { 
			$argn=substr($_SERVER['argv'][$i],1);
			$args[$argn]=true;
			continue; 
		}
		if ($argn!='') {
			$args[$argn]=$_SERVER['argv'][$i];
			$argn='';
		} else {
			$args['_other'][]=$_SERVER['argv'][$i];
		}
	}
	
	return $args;
}
?>